#include "../binary_c.h"
No_empty_translation_unit_warning;


void table_comenv(struct store_t * Restrict const store Maybe_unused)
{
#ifdef COMENV_WANG2016

#define MAXR_DATA                                   \
    1.0,160.0,                                      \
        2.0,120.0,                                  \
        3.0,140.0,                                  \
        4.0,150.0,                                  \
        6.0,240.0,                                  \
        8.0,370.0,                                  \
        10.0,550.0,                                 \
        12.0,700.0,                                 \
        15.0,900.0,                                 \
        18.0,1100.0,                                \
        20.0,1200.0,                                \
        25.0,1500.0,                                \
        30.0,1300.0,                                \
        35.0,1550.0,                                \
        40.0,1700.0,                                \
        45.0,2000.0,                                \
        50.0,2200.0,                                \
        60.0,1100.0

    NewDataTable_from_Array(
        MAXR_DATA,
        store->comenv_maxR_table,
        1,1,18);
/*
    printf("Made data \n");
    {
        int j;
        for(j=0;j<18;j++)
        {
            printf("MAXR %d %g %g\n",
                   j,
                   *(store->comenv_maxR_table->data+j*2+0),
                   *(store->comenv_maxR_table->data+j*2+1));
        }
    }
*/
    double tableh1[] = {
    1, 0.439377,0.00633475,-0.00046,1.05e-05,-1.11e-07,5.51e-10,-1.05e-12,
    2, 0.4583,-0.0664917,0.0128096,-0.00079697,2.35e-05,-3.33e-07,1.83e-09,
    3, 1.32159,-0.511108,0.0697982,-0.00423445,0.000129527,-1.96e-06,1.16e-08,
    4, 1.06003,-0.259126,0.021464,-0.000824166,1.64e-05,-1.63e-07,6.48e-10,
    6, -0.0802206,0.0187177,-0.00159932,4.43e-05,-5.53e-07,3.21e-09,-7.08e-12,
    8, -0.035692,0.00557222,-0.000485211,8.19e-06,-5.94e-08,1.97e-10,-2.46e-13,
    10, -0.0180579,-0.000377557,-0.000140871,1.79e-06,-9.01e-09,2.03e-11,-1.7e-14,
    12, 0.0030461,-0.00295418,-4.77e-05,5.48e-07,-2.16e-09,3.69e-12,-2.31e-15,
    15, -0.0281159,-0.00286523,-2.06e-05,1.88e-07,-5.34e-10,6.45e-13,-2.85e-16,
    18, -0.0115553,-0.00112965,-3.41e-05,1.73e-07,-3.37e-10,2.89e-13,-9.07e-17,
    20, 0.0333,-0.00277,-1.69e-05,9.48e-08,-1.77e-10,1.4e-13,-4.02e-17,
    25, -0.0798056,-0.00153937,-1.62e-05,6.42e-08,-9.17e-11,5.65e-14,-1.26e-17,
    30, -0.0687211,-0.0044393,7.66e-06,-5.86e-09,-9.7e-13,3.75e-15,-1.41e-18,
    35, -0.0868342,-0.00568376,1.61e-05,-2.79e-08,2.67e-11,-1.29e-14,2.48e-18,
    40, -0.113573,-0.00623641,1.8e-05,-2.96e-08,2.58e-11,-1.13e-14,1.94e-18,
    45, -0.090331,-0.0078733,2.16e-05,-3.12e-08,2.35e-11,-8.79e-15,1.29e-18,
    50, -0.0778474,-0.0082649,2e-05,-2.52e-08,1.65e-11,-5.39e-15,6.94e-19,
    60, -0.137506,-0.00819147,2.72e-05,-5.69e-08,6.76e-11,-4.18e-14,1.04e-17
    };

double tableh2[] = {
    1, 0.439377,0.00633475,-0.00046,1.05e-05,-1.11e-07,5.51e-10,-1.05e-12,
    2, 1.50385,-0.307828,0.0339266,-0.00191514,5.72e-05,-8.51e-07,4.97e-09,
    3, -34.4723,8.28456,-0.792027,0.0392131,-0.00106389,1.5e-05,-8.66e-08,
    4, -158.214,21.3665,-1.17563,0.0338289,-0.000537603,4.48e-06,-1.53e-08,
    6, 73.5586,-4.77761,0.124527,-0.00167956,1.24e-05,-4.79e-08,7.56e-11,
    8, -2.36507,0.124227,-0.00273529,2.83e-05,-1.5e-07,3.93e-10,-4.04e-13,
    10, -3.62027,0.112281,-0.00147837,9.22e-06,-2.96e-08,4.74e-11,-2.99e-14,
    12, -3527.28,49.2222,-0.284377,0.000870754,-1.49e-06,1.35e-09,-5.09e-13,
    15, -43390.8,415.542,-1.65272,0.00349447,-4.14e-06,2.61e-09,-6.84e-13,
    18, -0.0115553,-0.00112965,-3.41e-05,1.73e-07,-3.37e-10,2.89e-13,-9.07e-17,
    20, 0.0333,-0.00277,-1.69e-05,9.48e-08,-1.77e-10,1.4e-13,-4.02e-17,
    25, -0.0798056,-0.00153937,-1.62e-05,6.42e-08,-9.17e-11,5.65e-14,-1.26e-17,
    30, -0.0687211,-0.0044393,7.66e-06,-5.86e-09,-9.7e-13,3.75e-15,-1.41e-18,
    35, -0.0868342,-0.00568376,1.61e-05,-2.79e-08,2.67e-11,-1.29e-14,2.48e-18,
    40, -0.113573,-0.00623641,1.8e-05,-2.96e-08,2.58e-11,-1.13e-14,1.94e-18,
    45, -0.090331,-0.0078733,2.16e-05,-3.12e-08,2.35e-11,-8.79e-15,1.29e-18,
    50, -0.0778474,-0.0082649,2e-05,-2.52e-08,1.65e-11,-5.39e-15,6.94e-19,
    60, -0.137506,-0.00819147,2.72e-05,-5.69e-08,6.76e-11,-4.18e-14,1.04e-17
    };

double tableh3[] = {
    1,  0.439377,0.00633475,-0.00046,1.05e-05,-1.11e-07,5.51e-10,-1.05e-12,
    2, 0.800947,-0.0881628,0.00519055,-0.000134579,1.77e-06,-1.14e-08,2.9e-11,
    3, 1.76136,-0.210912,0.0103654,-0.000222355,2.4e-06,-1.29e-08,2.73e-11,
    4, 6.21658,-0.610564,0.0227716,-0.000409896,3.88e-06,-1.86e-08,3.55e-11,
    6, 6.44589,-0.314137,0.00564435,-5.18e-05,2.67e-07,-7.4e-10,8.6e-13,
    8, 0.414442,-0.0254334,0.000380787,-3.75e-06,2.07e-08,-5.39e-11,5.25e-14,
    10, 0.870256,-0.0352823,0.000383239,-2.32e-06,7.54e-09,-1.2e-11,7.31e-15,
    12, -1123.41,13.3917,-0.0655278,0.000168289,-2.39e-07,1.79e-10,-5.48e-14,
    15, 401.376,-3.33814,0.0112063,-1.93e-05,1.77e-08,-7.96e-12,1.27e-15,
    18, -0.0115553,-0.00112965,-3.41e-05,1.73e-07,-3.37e-10,2.89e-13,-9.07e-17,
    20, 0.0333,-0.00277,-1.69e-05,9.48e-08,-1.77e-10,1.4e-13,-4.02e-17,
    25, -0.0798056,-0.00153937,-1.62e-05,6.42e-08,-9.17e-11,5.65e-14,-1.26e-17,
    30, -0.0687211,-0.0044393,7.66e-06,-5.86e-09,-9.7e-13,3.75e-15,-1.41e-18,
    35, -0.0868342,-0.00568376,1.61e-05,-2.79e-08,2.67e-11,-1.29e-14,2.48e-18,
    40, -0.113573,-0.00623641,1.8e-05,-2.96e-08,2.58e-11,-1.13e-14,1.94e-18,
    45, -0.090331,-0.0078733,2.16e-05,-3.12e-08,2.35e-11,-8.79e-15,1.29e-18,
    50, -0.0778474,-0.0082649,2e-05,-2.52e-08,1.65e-11,-5.39e-15,6.94e-19,
    60, -0.137506,-0.00819147,2.72e-05,-5.69e-08,6.76e-11,-4.18e-14,1.04e-17
    };
/* blue */
double tableb1[] = {
    1, 0.0474861,-0.00181381,-0.000202148,5.51e-06,-6.12e-08,3.13e-10,-6.06e-13,
    2, -0.0556283,-0.0202789,0.00665017,-0.000473348,1.49e-05,-2.18e-07,1.23e-09,
    3, 0.553601,-0.322402,0.04138,-0.00228113,6.15e-05,-7.87e-07,3.71e-09,
    4, 0.396069,-0.16036,0.0105285,-0.000277383,2.93e-06,-4.06e-09,-7.92e-11,
    6, -0.181117,-0.00793044,-0.000669357,2.93e-05,-4.24e-07,2.63e-09,-6e-12,
    8, -0.167247,-0.00963629,-0.000147715,4.83e-06,-4.17e-08,1.5e-10,-1.95e-13,
    10, -0.190593,-0.00893087,8.17e-06,6.41e-07,-4.49e-09,1.14e-11,-1.01e-14,
    12, -0.179897,-0.00786612,1.32e-05,2.14e-07,-1.2e-09,2.31e-12,-1.53e-15,
    15, -0.189058,-0.00684583,1.38e-05,6.09e-08,-2.87e-10,4.01e-13,-1.89e-16,
    18, -0.193,-0.00582819,1.91e-06,5.64e-08,-1.57e-10,1.58e-13,-5.41e-17,
    20, -0.236293,-0.00492,-6.45e-07,4.58e-08,-1.07e-10,9.55e-14,-2.93e-17,
    25, -0.217138,-0.00529164,4.59e-06,1.57e-08,-3.82e-11,2.89e-14,-7.22e-18,
    30, -0.168597,-0.00818586,2.91e-05,-5.99e-08,6.65e-11,-3.71e-14,8.18e-18,
    35, -0.178467,-0.00822188,2.75e-05,-5.09e-08,4.98e-11,-2.42e-14,4.64e-18,
    40, -0.183811,-0.00830964,2.59e-05,-4.35e-08,3.81e-11,-1.66e-14,2.83e-18,
    45, -0.165033,-0.00897789,2.51e-05,-3.64e-08,2.74e-11,-1.03e-14,1.5e-18,
    50, -0.17357,-0.00858971,2.07e-05,-2.6e-08,1.71e-11,-5.58e-15,7.2e-19,
    60, -0.232113,-0.00821668,2.75e-05,-5.78e-08,6.9e-11,-4.28e-14,1.07e-17
    };

double tableb2[] = {
    1, 0.0474861,-0.00181381,-0.000202148,5.51e-06,-6.12e-08,3.13e-10,-6.06e-13,
    2, 0.0788949,-0.0173553,0.0018805,-0.000145636,5.81e-06,-1.06e-07,7.16e-10,
    3, -21.2642,4.99864,-0.474357,0.0233851,-0.000633095,8.94e-06,-5.15e-08,
    4, -113.513,15.1502,-0.827531,0.0236765,-0.000374536,3.11e-06,-1.06e-08,
    6, 77.9032,-4.98147,0.126968,-0.00167301,1.21e-05,-4.56e-08,7.05e-11,
    8, -4.53374,0.212107,-0.00436616,4.29e-05,-2.17e-07,5.44e-10,-5.37e-13,
    10, -4.03043,0.107086,-0.00130822,7.39e-06,-2.07e-08,2.77e-11,-1.36e-14,
    12, -4066.07,56.0114,-0.319954,0.000969959,-1.65e-06,1.48e-09,-5.54e-13,
    15, -38341.9,366.922,-1.45847,0.00308221,-3.65e-06,2.3e-09,-6.03e-13,
    18, -0.193,-0.00582819,1.91e-06,5.64e-08,-1.57e-10,1.58e-13,-5.41e-17,
    20, -0.236293,-0.00492,-6.45e-07,4.58e-08,-1.07e-10,9.55e-14,-2.93e-17,
    25, -0.217138,-0.00529164,4.59e-06,1.57e-08,-3.82e-11,2.89e-14,-7.22e-18,
    30, -0.168597,-0.00818586,2.91e-05,-5.99e-08,6.65e-11,-3.71e-14,8.18e-18,
    35, -0.178467,-0.00822188,2.75e-05,-5.09e-08,4.98e-11,-2.42e-14,4.64e-18,
    40, -0.183811,-0.00830964,2.59e-05,-4.35e-08,3.81e-11,-1.66e-14,2.83e-18,
    45, -0.165033,-0.00897789,2.51e-05,-3.64e-08,2.74e-11,-1.03e-14,1.5e-18,
    50, -0.17357,-0.00858971,2.07e-05,-2.6e-08,1.71e-11,-5.58e-15,7.2e-19,
    60, -0.232113,-0.00821668,2.75e-05,-5.78e-08,6.9e-11,-4.28e-14,1.07e-17
    };

double tableb3[] = {
    1, 0.0474861,-0.00181381,-0.000202148,5.51e-06,-6.12e-08,3.13e-10,-6.06e-13,
    2, 0.0425168,-0.0171898,0.000736229,-1.26e-05,1.02e-07,-3.85e-10,5.44e-13,
    3, -0.304912,0.0164256,-0.000214159,9.87e-07,1.3e-09,-2.05e-11,3.98e-14,
    4, -0.865298,0.0233953,-0.000167028,2.4e-07,2.51e-09,-1.07e-11,1.22e-14,
    6, 1.9588,-0.111667,0.00164668,-1.08e-05,3.63e-08,-6.01e-11,3.92e-14,
    8, 0.288647,-0.0269008,0.000212298,-7.41e-07,1.58e-09,-2.06e-12,1.25e-15,
    10, -1.90866,0.0373271,-0.000439988,2.22e-06,-5.37e-09,6.26e-12,-2.83e-15,
    12, -650.907,7.75499,-0.0379613,9.75e-05,-1.39e-07,1.03e-10,-3.17e-14,
    15, 511.573,-4.48304,0.0160659,-3.01e-05,3.11e-08,-1.67e-11,3.61e-15,
    18, -0.193,-0.00582819,1.91e-06,5.64e-08,-1.57e-10,1.58e-13,-5.41e-17,
    20, -0.236293,-0.00492,-6.45e-07,4.58e-08,-1.07e-10,9.55e-14,-2.93e-17,
    25, -0.217138,-0.00529164,4.59e-06,1.57e-08,-3.82e-11,2.89e-14,-7.22e-18,
    30, -0.168597,-0.00818586,2.91e-05,-5.99e-08,6.65e-11,-3.71e-14,8.18e-18,
    35, -0.178467,-0.00822188,2.75e-05,-5.09e-08,4.98e-11,-2.42e-14,4.64e-18,
    40, -0.183811,-0.00830964,2.59e-05,-4.35e-08,3.81e-11,-1.66e-14,2.83e-18,
    45, -0.165033,-0.00897789,2.51e-05,-3.64e-08,2.74e-11,-1.03e-14,1.5e-18,
    50, -0.17357,-0.00858971,2.07e-05,-2.6e-08,1.71e-11,-5.58e-15,7.2e-19,
    60, -0.232113,-0.00821668,2.75e-05,-5.78e-08,6.9e-11,-4.28e-14,1.07e-17
    };
/* green */
double tableg1[] = {
    1, -0.229505,-0.00664297,-7.9e-05,3.36e-06,-4.09e-08,2.18e-10,-4.3e-13,
    2, -0.365205,-0.00804847,0.00471868,-0.000366995,1.19e-05,-1.79e-07,1.02e-09,
    3, 0.147497,-0.255352,0.0310092,-0.00156705,3.67e-05,-3.63e-07,8.52e-10,
    4, 0.0309598,-0.128293,0.00684081,-9.09e-05,-1.69e-06,5.09e-08,-3.31e-10,
    6, -0.333387,-0.0220174,-0.00015568,2.03e-05,-3.38e-07,2.21e-09,-5.17e-12,
    8, -0.332645,-0.0190691,6.84e-05,2.52e-06,-2.87e-08,1.12e-10,-1.52e-13,
    10, -0.380448,-0.015346,0.000118835,-2.39e-07,-8.97e-10,4.2e-12,-4.47e-15,
    12, -0.38247,-0.012417,6.94e-05,-1.11e-07,-2.31e-10,8.69e-13,-6.91e-16,
    15, -0.384916,-0.0111889,5.15e-05,-8.88e-08,2.15e-11,8.41e-14,-6.07e-17,
    18, -0.428,-0.010179,3.42e-05,-4.69e-08,4.25e-12,3.87e-14,-2.07e-17,
    20, -0.572664,-0.0069989,1.41e-05,1.46e-09,-4.4e-11,5.3e-14,-1.86e-17,
    25, -0.44599,-0.00941642,2.67e-05,-3.53e-08,1.83e-11,-7.71e-16,-1.27e-18,
    30, -0.360619,-0.0132897,5.8e-05,-1.33e-07,1.57e-10,-9.18e-14,2.1e-17,
    35, -0.368625,-0.0123061,4.58e-05,-8.8e-08,8.71e-11,-4.25e-14,8.12e-18,
    40, -0.349967,-0.0120342,4.03e-05,-6.88e-08,6.05e-11,-2.62e-14,4.45e-18,
    45, -0.334563,-0.0116183,3.36e-05,-4.94e-08,3.75e-11,-1.4e-14,2.06e-18,
    50, -0.387442,-0.00985878,2.4e-05,-3.02e-08,1.99e-11,-6.55e-15,8.51e-19,
    60, -0.475333,-0.00867825,3e-05,-6.42e-08,7.76e-11,-4.86e-14,1.22e-17
    };

double tableg2[] = {
    1, -0.229505,-0.00664297,-7.9e-05,3.36e-06,-4.09e-08,2.18e-10,-4.3e-13,
    2, -0.318594,0.0135305,-0.00171517,6.52e-05,-7.02e-07,-6.6e-09,1.24e-10,
    3, -17.0379,3.9123,-0.369651,0.018176,-0.000491475,6.94e-06,-4e-08,
    4, -95.3049,12.6128,-0.686025,0.0195623,-0.000308629,2.56e-06,-8.69e-09,
    6, 77.711,-4.94718,0.124918,-0.00162958,1.17e-05,-4.36e-08,6.66e-11,
    8, -5.64128,0.250489,-0.0050659,4.9e-05,-2.44e-07,6.02e-10,-5.86e-13,
    10, -4.19633,0.0976874,-0.00112781,5.8e-06,-1.38e-08,1.33e-11,-2.25e-15,
    12, -4223.89,57.8146,-0.328432,0.000990866,-1.67e-06,1.5e-09,-5.6e-13,
    15, -30256.1,289.154,-1.14796,0.00242333,-2.87e-06,1.81e-09,-4.72e-13,
    18, -0.428,-0.010179,3.42e-05,-4.69e-08,4.25e-12,3.87e-14,-2.07e-17,
    20, -0.572664,-0.0069989,1.41e-05,1.46e-09,-4.4e-11,5.3e-14,-1.86e-17,
    25, -0.44599,-0.00941642,2.67e-05,-3.53e-08,1.83e-11,-7.71e-16,-1.27e-18,
    30, -0.360619,-0.0132897,5.8e-05,-1.33e-07,1.57e-10,-9.18e-14,2.1e-17,
    35, -0.368625,-0.0123061,4.58e-05,-8.8e-08,8.71e-11,-4.25e-14,8.12e-18,
    40, -0.349967,-0.0120342,4.03e-05,-6.88e-08,6.05e-11,-2.62e-14,4.45e-18,
    45, -0.334563,-0.0116183,3.36e-05,-4.94e-08,3.75e-11,-1.4e-14,2.06e-18,
    50, -0.387442,-0.00985878,2.4e-05,-3.02e-08,1.99e-11,-6.55e-15,8.51e-19,
    60, -0.475333,-0.00867825,3e-05,-6.42e-08,7.76e-11,-4.86e-14,1.22e-17
    };

double tableg3[] = {
    1, -0.229505,-0.00664297,-7.9e-05,3.36e-06,-4.09e-08,2.18e-10,-4.3e-13,
    2, -0.278858,-0.0111753,0.000408553,-6.72e-06,5.31e-08,-1.95e-10,2.66e-13,
    3, -0.556788,0.0136936,-0.000219799,1.53e-06,-4.85e-09,5.74e-12,5.16e-17,
    4, -1.3186,0.0353038,-0.000452023,2.89e-06,-9.71e-09,1.63e-11,-1.08e-14,
    6, 0.571517,-0.0686417,0.00102131,-6.51e-06,2.08e-08,-3.27e-11,2.02e-14,
    8, 0.119653,-0.0317122,0.000260052,-8.94e-07,1.57e-09,-1.39e-12,4.91e-16,
    10, -2.59214,0.0484842,-0.000573382,2.98e-06,-7.57e-09,9.32e-12,-4.48e-15,
    12, -408.155,4.86118,-0.0238404,6.14e-05,-8.74e-08,6.54e-11,-2.01e-14,
    15, 756.345,-6.90155,0.0259368,-5.15e-05,5.69e-08,-3.32e-11,7.97e-15,
    18, -0.428,-0.010179,3.42e-05,-4.69e-08,4.25e-12,3.87e-14,-2.07e-17,
    20, -0.572664,-0.0069989,1.41e-05,1.46e-09,-4.4e-11,5.3e-14,-1.86e-17,
    25, -0.44599,-0.00941642,2.67e-05,-3.53e-08,1.83e-11,-7.71e-16,-1.27e-18,
    30, -0.360619,-0.0132897,5.8e-05,-1.33e-07,1.57e-10,-9.18e-14,2.1e-17,
    35, -0.368625,-0.0123061,4.58e-05,-8.8e-08,8.71e-11,-4.25e-14,8.12e-18,
    40, -0.349967,-0.0120342,4.03e-05,-6.88e-08,6.05e-11,-2.62e-14,4.45e-18,
    45, -0.334563,-0.0116183,3.36e-05,-4.94e-08,3.75e-11,-1.4e-14,2.06e-18,
    50, -0.387442,-0.00985878,2.4e-05,-3.02e-08,1.99e-11,-6.55e-15,8.51e-19,
    60, -0.475333,-0.00867825,3e-05,-6.42e-08,7.76e-11,-4.86e-14,1.22e-17
    };

#define COMENV_TABLE_SIZE (8*18*sizeof(double))
#define MAKE_COMENV_TABLE(TABLE)                \
    store->TABLE = Malloc(COMENV_TABLE_SIZE); \
    memcpy(store->TABLE,                      \
           (TABLE),                             \
           COMENV_TABLE_SIZE);
    MAKE_COMENV_TABLE(tableg1);
    MAKE_COMENV_TABLE(tableg2);
    MAKE_COMENV_TABLE(tableg3);
    MAKE_COMENV_TABLE(tableb1);
    MAKE_COMENV_TABLE(tableb2);
    MAKE_COMENV_TABLE(tableb3);
    MAKE_COMENV_TABLE(tableh1);
    MAKE_COMENV_TABLE(tableh2);
    MAKE_COMENV_TABLE(tableh3);

#endif // COMENV_WANG2016

}
